#include "stdafx.h"
#include "Skills.h"
#include "FormationSkills.h"
#include "LogManager.h"
#include "WorldObjects.h"

extern CConfig *cfg;           // FIXME
extern FILE *m_ff;             // FIXME

// FIXME: pre aku neurcitost sa pozerat za loptou
#define INVALID(diff, dist) ((((dist)>5) && ((diff)>(1.0*(dist)))) || (((dist)<5) && ((diff)>3)))

// FIXME
extern double kkx;
extern double kky;

// GOALIE:
void CTeamSkills::GoalieBehave(CLocalAgent *pa)
{
    CBall *pBall = pa->GetWorldModel()->GetBall();
    C2DVector toball = pBall->GetPosition() - pa->GetPosition();
    double diff = pBall->GetPosition().GetDiffusion();
    double dist = toball.GetDistance();

    if (pa->GetPlayMode() == PM_FreeKick_Left) 
    {
        C2DVector homepos = C2DVector(-40, 20);
        if ((pa->GetPosition() - homepos).GetDistance() > 5) {
            pa->bskl->Move(pa, homepos);
            return;
        }
        
        CAgent *a = pa->bskl->NearestFriendToBall(pa);
        if (a == NULL) {
            pa->bskl->KickTo(pa, pa->field->GetGoal(GT_R), 100.0);			   
        } else {
            pa->bskl->KickTo(pa, a->GetPosition());
        }
    }

    if ((((pBall->GetSeeStatus() & SEE_ANGLE) && (pBall->GetSeeStatus() & SEE_DISTANCE)) ||
        ((pBall->GetSeeStatus() & EXPECTED_ANGLE) && (pBall->GetSeeStatus() & EXPECTED_DISTANCE))) &&
        (!INVALID(diff,dist)))
    {
        
        LOGMSG(1, "[%d] AGENT x:%lf, y:%lf", pa->GetGameTime().m_nAllCycles, pa->GetPosition().GetX(), pa->GetPosition().GetY());
        //bskl->GetBallInterceptPosition(this, pBall->GetSpeed());
        
        if (pa->bskl->BallKickable(pa)) 
        {
            // bskl->TurnNeckTo(this, field->GetGoal(GT_L));
            
            CAgent *a = pa->bskl->NearestFriendToBall(pa);
            if (a == NULL) 
            {
                // bskl->KickTo(this, field->GetGoal(GT_R), 50.0);
                pa->bskl->Catch(pa, (pa->bskl->RelVectorTo(pa, pBall->GetPosition())).GetAngle());
            }
            else 
            {
                // bskl->KickTo(this, a->GetPosition(), 50.0);
                pa->bskl->Catch(pa, (pa->bskl->RelVectorTo(pa, pBall->GetPosition())).GetAngle());             
            }
            
        } 
        else 
        {
            //  bskl->TurnNeckStraight(this);
            
            // C2DVector ballpos = pBall->GetPosition();
            
            C2DVector ballpos = pa->bskl->GetBallInterceptPosition(pa, pBall->GetSpeed());
            
            if (ballpos.GetX() == NOT_EXISTING) ballpos = pBall->GetPosition();
                        
            //bskl->GoTo(this, ballpos, 100.0);
            //bskl->TurnTo(this, ballpos);
            
            //jeeff (brankar):
            //ak je lopta prilis daleko chod domov
            double ballDist = ballpos.GetDistance();
            if ((ballpos.GetX() > -40) || (fabs(ballpos.GetY()) > 18)) // || ballpos.GetX() > 0)
            {
                C2DVector homePos = pa->fskl->GetMyHomePosition(pa);					
                
                double r=pa->field->GetGoalSize();
                double alfa = atan2(ballpos.GetY(), ballpos.GetX()+52.5);
                
                homePos.SetY(sin(alfa) * r);
                homePos.SetX(cos(alfa)*r - 52.5);
                //homePos.SetX(7.2);
                //homePos.SetY(-52.3);
                
                
                double homeDist = homePos.GetDistance();
                C2DVector toHomePos = pa->GetPosition();
                toHomePos.SetXY(toHomePos.GetX() - homePos.GetX(), toHomePos.GetY() - homePos.GetY());
                if (toHomePos.GetDistance() < 1.0)
                {
                    pa->bskl->TurnTo(pa, ballpos);
                }
                else
                {
                    pa->bskl->GoTo(pa, homePos, 100.0);
                }
                
            }
            else
            {
                pa->bskl->GoTo(pa, ballpos, 100.0);
            }
        }
        
        
        
        ////            LOGMSG(1, "GAMETIME %d", m_cGameTime);
        ////            LOGMSG(1, "MyPosition  X %lf, Y %lf", GetPosition().GetX(), GetPosition().GetY());
        ////            LOGMSG(1, "BallPosition  X %lf, Y %lf", pBall->GetPosition().GetX(), pBall->GetPosition().GetY());
        ////            C2DVector ccc2 = bskl->GetBallInterceptPosition(this, cccc);
        ////            LOGMSG(1, "BallInterceptPosition X %lf, Y %lf", ccc2.GetX(), ccc2.GetY());
        
        
        
    } 
    else 
    {
        //bskl->TurnNeckStraight(this);
        //bskl->Turn2(this, 4.50);   // spravit skill, ktory najde loptu (mal by pockat na perception, moze sa tocit o 45? stupnov)
        pa->bskl->Turn(pa, DegToRad(45));
    }
}

// naplanovanie chodenia do pozicie cPlanPos na dalsich nPlanTime sim. krokov
void CTeamSkills::PlanGoTo(CLocalAgent *pa, C2DVector cPlanPos, int nPlanTime)
{
    pa->tdata->SetPlanPos(nPlanTime, cPlanPos);
}

bool CTeamSkills::DoPlan(CLocalAgent *pa)
// vrati false, ak nie je co vykonavat v ramci planu (plan splneny/nezadany)
{
    int nPlanTime;
    C2DVector cPlanPos;

    // zistime si, co mame naplanovane -> ak nic, tak koncime
    pa->tdata->GetPlanPos(nPlanTime, cPlanPos);

    if (nPlanTime <= 0) return false;

    nPlanTime--;
    // ak uz sme na mieste, tak koniec (+ vrat false)
    if ((pa->GetPosition() - cPlanPos).GetDistance() <= 5) {
        nPlanTime = 0;
        pa->tdata->SetPlanPos(nPlanTime, cPlanPos);
        return false;
    }

    pa->bskl->GoTo(pa, cPlanPos, 100.0);

    // FIXME: musime nejak decnut cas
    pa->tdata->SetPlanPos(nPlanTime, cPlanPos);
    return true;
}

void CTeamSkills::OffenderBehave(CLocalAgent *pa, C2DVector homepos)
{
    CBall *pBall = pa->GetWorldModel()->GetBall();
    C2DVector toball = pBall->GetPosition() - pa->GetPosition();
    double diff = pBall->GetPosition().GetDiffusion();
    double dist = toball.GetDistance();
//    fprintf(m_ff, "diff/dist: %f / %f\n",(float)diff, (float)dist);
    
    if ((((pBall->GetSeeStatus() & SEE_ANGLE) && (pBall->GetSeeStatus() & SEE_DISTANCE)) ||
        ((pBall->GetSeeStatus() & EXPECTED_ANGLE) && (pBall->GetSeeStatus() & EXPECTED_DISTANCE))) &&
        (!INVALID(diff,dist)))    
    {
     
        LOGMSG(1, "[%d] AGENT x:%lf, y:%lf", pa->GetGameTime().m_nAllCycles, pa->GetPosition().GetX(), pa->GetPosition().GetY());
        // bskl->GetBallInterceptPosition(this, pBall->GetSpeed());

        // mame pokracovat v "plane"? -> ak ano, tak nic ine uz nemozeme robit
        if (DoPlan(pa)) return;
        
        if (pa->bskl->BallKickable(pa)) {
            // bskl->TurnNeckTo(this, field->GetGoal(GT_L));
            
            // nahrame najblizsiemu spoluhracovi, ak je smerom na superovu
            // branu, inak kopneme rovno do brany
            CAgent *a = pa->bskl->NearestFriendToBall(pa);
            if ((a == NULL) || ((a != NULL) && ((a->GetPosition() - pa->GetPosition()).GetX()<0))) {
                pa->bskl->KickTo(pa, pa->field->GetGoal(GT_R), 50.0);
            } else {
                pa->bskl->KickTo(pa, a->GetPosition(), 50.0);
            }
          
        } else {
            //bskl->TurnNeckStraight(this);
            
            //C2DVector ballpos = pBall->GetPosition();
            
            C2DVector ballpos = pa->bskl->GetBallInterceptPosition(pa, pBall->GetSpeed());
            
            if (ballpos.GetX() == NOT_EXISTING) ballpos = pBall->GetPosition();
            // FIXME: vizualizacia incerceptposition
            kkx = ballpos.GetX();
            kky = ballpos.GetY();
            
            // zodpovednost za loptu??
            CAgent *a = pa->bskl->NearestFriendToBall(pa);
            if (a == NULL) {
                pa->bskl->GoTo(pa, ballpos, 100.0);
                //bskl->FaceGoTo(this, pBall->GetPosition(), ballpos, 100.0);
            } else {
                //FIXME: jeho intercept
                if ((ballpos - pa->GetPosition()).GetDistance() <= (ballpos - (C2DVector)a->GetPosition()).GetDistance()) {
                    pa->bskl->GoTo(pa, ballpos, 100.0);
                    //bskl->FaceGoTo(this, pBall->GetPosition(), ballpos, 100.0);
                } else {
                    //bskl->TurnNeckStraight(this);
                    if ((pa->GetPosition() - homepos).GetDistance() > 5) {
                        // naplanuj presun do homepos a vykonavaj 
                        // to dalsich 8 krokov
                        PlanGoTo(pa, homepos, 8);
                    } else pa->bskl->TurnTo(pa, ballpos);
                    
                }
            }
        }       
    } 
    else 
    {
        //bskl->TurnNeckStraight(this);
        //bskl->Turn2(this, 4.50);   // spravit skill, ktory najde loptu (mal by pockat na perception, moze sa tocit o 45? stupnov)
        pa->bskl->Turn(pa, DegToRad(45));
    }

}

// rutina NeckTest testuje turnnecky a demonstruje pouzitie skillsy FaceGoTo
void NeckTest(CLocalAgent *pa)
{
    C2DVector destpos(0,0);
    C2DVector lookpos = pa->GetWorldModel()->GetBall()->GetPosition();

    kkx=lookpos.GetX();
    kky=lookpos.GetY();

    fprintf(m_ff, "-> neck_direction: %f\n",(float)RadToDeg(pa->GetNeckDirection()));
    fprintf(m_ff, "-> neck_direction(r): %f\n",(float)pa->GetNeckDirection());
    if ((pa->GetPosition() - destpos).GetDistance()<5) {
        pa->bskl->TurnNeckTo(pa, lookpos);
        return;

        static int tt=0;
        static int tt2=180/5;
        if (tt) pa->bskl->TurnNeck(pa, DegToRad(+5));
        else pa->bskl->TurnNeck(pa, DegToRad(-5));
        double dir = pa->GetNeckDirection() - pa->GetDirection();
        if (RadToDeg(dir) > 60) tt=0;
        if (RadToDeg(dir) < -60) tt=1;

//        if (tt2-- <= 0) {
//            tt = !tt;
//            tt2=180/5;
//        }
        pa->bskl->Turn(pa, 0);
    } else 
        pa->bskl->FaceGoTo(pa, lookpos, destpos, 100.0);
}

void CTeamSkills::Behave(CLocalAgent *pa)
{   
    // Priklad: homepos vypocitame podla formacie a do dalsich rutin 
    //          ho posleme ako parameter
    C2DVector homepos = pa->fskl->GetMyHomePosition(pa);
//  C2DVector homepos = C2DVector(-40, 20);
    
    // FIXMEE: ak je beforekickoff a nie sme na mieste, tak sa premiestnime
    if (pa->GetPlayMode() == PM_BeforeKickOff) {
        //          bskl->Turn(this, 10);
        if ((pa->GetPosition() - homepos).GetDistance() > 5) {
            pa->bskl->Move(pa, homepos);
            return;
        }
    }
    
//  else { bskl->GoTo(this, C2DVector(-10, -20), 20.0); }
//  else { bskl->GoTo(this, C2DVector(-20, 10), 20.0); }

//  NeckTest(pa); return;

    // ak bol hrac zinitializovany ako goalie, tak zavolame goalie-ho obsluhu
    if (pa->IsGoalie()) {
        GoalieBehave(pa);
    } else {
        // inak sme univerzalny utocnik
        OffenderBehave(pa, homepos);
    }
}

/*// testovanie turnnecku -> vykrutime hlavu nabok a chodime do kruhu opacne
static int ww=0;
if (ww++<2) {
    bskl->TurnNeck(this, DegToRad(-80));
    return;
}
static int ww2=0;
bskl->GoTo(this, field->GetGoal(GT_R), 100);
//if (ww2)
//    bskl->Dash(this, 100);
//else
//    bskl->Turn(this, DegToRad(10));
ww2 = !ww2;
return; */
