#ifndef TEAMSKILLS_H
#define TEAMSKILLS_H

#include "WorldGeometry.h"

class CLocalAgent;           // aby sme sa vyhli rekurzivnemu includovaniu
class CAgent;
class CBall;

class CTeamData
{
    int m_nPlanTime;
    C2DVector m_cPlanPos;

public:
    CTeamData() { m_nPlanTime = 0; };

    void SetPlanPos(int nPlanTime, C2DVector cPlanPos) { 
        m_nPlanTime = nPlanTime;  m_cPlanPos = cPlanPos;
    };
    void GetPlanPos(int &nPlanTime, C2DVector &cPlanPos) { 
        nPlanTime = m_nPlanTime;  cPlanPos = m_cPlanPos;
    };
};

class CTeamSkills
{
protected:
    void PlanGoTo(CLocalAgent *pa, C2DVector cPlanPos, int nPlanTime);
    bool DoPlan(CLocalAgent *pa);

public:
    void Behave(CLocalAgent *pa);

    void GoalieBehave(CLocalAgent *pa);
    void OffenderBehave(CLocalAgent *pa, C2DVector homepos);
};

#endif  // TEAMSKILLS_H
